#!/usr/bin/python3
# coding: utf-8
# -*- coding: utf-8 -*-

# A Fediverse (decentralized social network, for instance using Mastodon) bot

from mastodon import StreamListener
from lxml import html
from logging.handlers import RotatingFileHandler
from pprint import pprint
from utils.config import get_parameter, init_log, init_mastodon

import requests, os, random, sys, time, json, logging

def post_img(mastodon, text, visibility, log, config):
    img_path = get_parameter("img_path", config)
    file = random.choice(os.listdir(img_path+"/")) 
    image_byte = open(img_path+"/"+file, "rb").read()

    file, ext = os.path.splitext(file)
    mime_dict = {'.jpg': 'image/jpeg', '.jpe': 'image/jpeg', '.jpeg': 'image/jpeg', '.png': 'image/png', '.gif': 'image/gif'}
    
    mime = mime_dict[str.lower(ext)]
    #try:

    #except KeyError:
    #    mime = None;
    #    pass

    media_dict = mastodon.media_post(image_byte, mime)
    mastodon.status_post("", None, media_ids=[media_dict], sensitive=True, visibility='public', spoiler_text="#NSFW")

def init_log(log_filepath):
    log = logging.getLogger()
    log.setLevel(logging.ERROR)
    formatter = logging.Formatter('%(asctime)s :: %(levelname)s :: %(message)s')

    file_handler = RotatingFileHandler(log_filepath, 'a', 1000000, 1)
    file_handler.setLevel(logging.ERROR)
    file_handler.setFormatter(formatter)
    log.addHandler(file_handler)

    stream_handler = logging.StreamHandler()
    stream_handler.setLevel(logging.ERROR)
    log.addHandler(stream_handler)

    return log

def main(): 
    config_file      = "config.txt"
    secrets_filepath = "secrets/secrets.txt"
    log_filepath     = "activity.log"
    log = init_log(log_filepath)
    mastodon = init_mastodon(config_file, secrets_filepath)
    post_img(mastodon, "NSFW", 1, log, config_file)

main()

